<?php
//are session cookies secure?

require_once("HTTP/Request2.php");
require_once("HTTP/Request2/Adapter/Curl.php");
require_once("util.php");

// returns null on either failure or non 200 status
function http_req ($url) {
  $request = new HTTP_Request2($url, HTTP_Request2::METHOD_GET);
  try {
    $response = $request->send();
    if (200 == $response->getStatus()) return $response->getBody();
  } catch (HTTP_Request2_Exception $e) { }
  return null;
}

////
function encode2($call2) {return urlencode(json_encode($call2));}
$urls=array("https://a.totp.me:8443/prot",
            "https://b1.totp.me:18443/prot2",
            "https://b2.totp.me:28443/prot2",
            "https://b3.totp.me:38443/prot2",
            "https://b4.totp.me:48443/prot2");
//$urls=array("http://192.168.56.1:8000/prot");
function fetch($urls, $action, $key, $arg) {
  if (count($urls)==0) throw new Exception("could not connect to any servers");
  $res=http_req($urls[0]."?action=".$action."&key=".$key."&arg=".$arg);
  return $res!=null ? $res : fetch(array_slice($urls,1),$action,$key,$arg);
}
function make_client_msg($key, $call2) {
  global $urls;
  return fetch($urls, "make-client-msg", $key, encode2($call2));
}
function decode_server_msg($key, $msg, $sid) {
  global $urls;
  $sid2 = $sid ? json_decode($sid) : 0;
  return json_decode(fetch(array_slice($urls,$sid2,1), "decode-server-msg",
                           $key, $msg));
}

////

//instead of storing callbacks,
//have the user write functions named auth_cb, prov_cb
//in the session you store: [reqid, "a"|"p"]
//otp_response looks this up, calls auth_cb or prov_cb
//those functions receive userid. they should use it to check
//whether it matches the userid that is tentatively authed by first factor

$reqs="totp:outstanding-reqs";
function push_outstanding_request(&$session, $oreq) {
  global $reqs;
  $x=aref($session,$reqs);
  if (!$x) $x=array();
  $x[$oreq[0]]=$oreq;
  $session[$reqs]=$x; //must reassign if you change internals of a session value
  return $x;
}
function remove_outstanding_request(&$session, $reqid) {
  global $reqs;
  $ans = $session[$reqs][$reqid];
  unset ($session[$reqs][$reqid]);
  return $ans;
}
$key=null;
function call1(&$session, $fn, $u, $hname) {
  global $key;
  $reqid = microtime();
  $oreq = array($reqid, $u, $hname);
  push_outstanding_request($session, $oreq);
  return make_client_msg($key, array($reqid, $fn, $u));
}
function prov(&$s, $u) { return call1($s, "prov", $u, "p"); }
function auth(&$s, $u) { return call1($s, "auth", $u, "a"); }

////

function otp_response(&$session) {
  global $key;
  $res2 = decode_server_msg($key, req_param("res"), req_param("sid"));
  $oreq = remove_outstanding_request($session, $res2[0]);
  if ($oreq[2] == "p")
    return prov_cb($oreq[1], count($res2[1]) != 0);
  else if ($oreq[2] == "a")
    return auth_cb($oreq[1], count($res2[1]) != 0);
  else
    throw new Exception("unknown handler function code");
}
?>
